100 REMark Calendar - Print an annual calendar on A4 sheet
102 REMark pjwitte September 7th 2003
104 rem V0.11, pjw, 2022 Jul 24, Qdos compatible (again)
106 :
108 REMark  **  Define and Init
110 :
112 RESTORE
114 :
116 box% = 2:               REMark Grid size
118 fdow = 1:               REMark First day of week (Sun = 0..6)
120 lsp% = 2:               REMark Lines between boxes
122 Gut$ = FILL$(" ", 4):   REMark Gutter (spaces between boxes)
124 lmrg% = 8:              REMark Left margin
126 outp$ = 'ram1_Cal_txt': REMark Output device
128 :
130 Init
132 :
134 REMark  **  Output harness
136 :
138 ch = FOP_OVER(outp$)
140 PrtCal3x4 2096, 1: REMark Year and month (1..12) to start
142 CLOSE#ch
144 REMark FI2_CALL outp$:         REMark Optional - or EX your favourite editor
146 :
148 REMark  **  12 month calendar in 3 x 4 grid
150 :
152 DEFine PROCedure PrtCal3x4(y%, stm%)
154 LOCal i, l, d, l%, m%, l$
156 GetMhd$: m% = stm%: l% = 0
158 FOR i = 1 TO 12
160  Calendar y% + l%, m%
162  m% = (m% MOD 12) + 1
164  IF m% = 1: l% = 1: REMark Flag new year
166 END FOR i
168 l% = 60 + LEN(Gut$) * 2: REMark Display width
170 PRINT#ch; TO lmrg%;
172 IF stm% <> 1 THEN
174  PRINT#ch; Center$(l%, 'Calendar for ' & y% & '/' & (y% + 1));
176 ELSE
178  PRINT#ch; Center$(l%, 'Calendar for ' & y%);
180 END IF
182 LF
184 m% = stm%
186 FOR i = 1 TO 12 STEP 3
188  REMark Print three months at a time
190  PRINT#ch; TO lmrg%; Center$(20, Mnth$(m%)); Gut$;
192  PRINT#ch; Center$(20, Mnth$((m% MOD 12) + 1)); Gut$;
194  PRINT#ch; Center$(20, Mnth$(((m% + 1) MOD 12) + 1));: LF
196 :
198  REMark Print weekday headers
200  FOR l = 1 TO 2: PRINT#ch; mhd$; Gut$;
202  PRINT#ch; mhd$;: LF
204 :
206  REMark Print one week line for each of 3 months
208  FOR l = 0 TO 5
210   l$ = ''
212   FOR d = 0 TO 6: l$ = l$ & Pad$(yr%((m% + 11) MOD 12, l, d)) & FILL$(' ', d <> 6)
214   l$ = l$ & Gut$
216   FOR d = 0 TO 6: l$ = l$ & Pad$(yr%(m% MOD 12, l, d)) & FILL$(' ', d <> 6)
218   l$ = l$ & Gut$
220   FOR d = 0 TO 6: l$ = l$ & Pad$(yr%((m% + 1) MOD 12, l, d)) & FILL$(' ', d <> 6)
222   FOR d = 1 TO LEN(l$)
224    IF l$(d) <> ' ': PRINT#ch; l$;: LF: EXIT d:
226   END FOR d
228  END FOR l
230  REMark Increment month, wrapping round year
232  m% = ((m% + 2) MOD 12) + 1
234 END FOR i
236 END DEFine PrtCal3x4
238 :
240 REMark  **  Date calculation stuff
242 :
244 DEFine PROCedure Init
246 LOCal i
248 DIM Mnth$(12, 10), Mnth%(12), yr%(11, 5, 6)
250 FOR i = 1 TO 12: READ Mnth$(i), Mnth%(i)
252 DATA 'January', -1, 'February', 30, 'March', 58, 'April', 89
254 DATA 'May', 119, 'June', 150, 'July', 180, 'August', 211
256 DATA 'September', 242, 'October', 272, 'November', 303, 'December', 333
258 END DEFine Init
260 :
262 DEFine PROCedure Calendar(y%, m%)
264 LOCal d, dy%, n%, l%
266 dy% = DOW%(y%, m%, 1): l% = 0: n% = m% - 1
268 FOR d = 1 TO LDM%(y%, m%)
270  dy% = DOW%(y%, m%, d)
272  yr%(n%, l%, dy%) = d
274  IF dy% = 6: l% = l% + 1
276 END FOR d
278 END DEFine Calendar
280 :
282 DEFine PROCedure GetMhd$
284 LOCal i, d$(4)
286 mhd$ = ''
288 FOR i = 0 TO 6
290  d$ = DAY$(86400 * (i + fdow))
292  mhd$ = mhd$ & d$(1 TO box%) & FILL$(' ', i <> 6)
294 END FOR i
296 END DEFine GetMhd$
298 :
300 DEFine FuNction LDM%(y%, m%)
302 LOCal dt$(20)
304 REMark Last date of month
306 dt$ = DATE$(Secs(y%, m%, 31))
308 IF dt$(10 TO 11) = 31: RETurn 31
310 RETurn 31 - dt$(10 TO 11)
312 END DEFine LDM%
314 :
316 DEFine FuNction DOW%(y%, m%, d%)
318 loc s
320 s = secs(y%, m%, d%)
322 if s < 0 then
324  RETurn INT((s + 4294967296) / 86400 - fdow) MOD 7
326 else
328  RETurn INT(s / 86400 - fdow) MOD 7
330 endif
332 END DEFine DOW%
334 :
336 DEFine FuNction Secs(y%, m%, d%)
338 LOCal s
340 s = Mnth%(m%)
342 IF m% > 2 AND y% MOD 4 = 0: s = s + 1
344 s = (s + d% + INT((y% - 1961) * 365.25)) * 86400
346 IF s <= 2147483647: RETurn s
348 ret s - 4294967296
350 END DEFine Secs
352 :
354 REMark  **  Misc routines
356 :
358 DEFine FuNction Pad$(n%)
360 IF n% = 0 THEN
362  RETurn FILL$(" ", box%)
364 ELSE
366  RETurn FILL$(" ", box% - LEN(n%)) & n%
368 END IF
370 END DEFine Pad$
372 :
374 DEFine PROCedure LF
376 LOCal i
378 FOR i = 1 TO lsp%: PRINT#ch
380 PRINT#ch; TO lmrg%;
382 END DEFine LF
384 :
386 DEFine FuNction Center$(w%, tx$)
388 LOCal l%, f%
390 l% = LEN(tx$)
392 IF l% * w% = 0: RETurn FILL$(' ', w%)
394 IF l% > w% THEN
396  f% = INT((l% - w%) / 2 + .5)
398  RETurn tx$(f% TO INT(f% + w% - .5))
400 ELSE
402  f% = INT((w% - l%) / 2)
404  RETurn FILL$(' ', f%) & tx$ & FILL$(' ', w% - f% - l%)
406 END IF
408 END DEFine Center$
410 :
